#!/usr/bin/perl
#
# SmoothWall CGIs
#
# This code is distributed under the terms of the GPL
#
# (c) The SmoothWall Team
#
# $Id: copfilter.cgi,v 0.00.0.3 2005/03/15 mmadlener
#



use strict;
use IO::Socket;
# enable only the following on debugging purpose
#use warnings;
#use CGI::Carp 'fatalsToBrowser';



################################################################################
##   Definitions
################################################################################

################Variable 3rd rules
my $OPTCOL = '';
my $lastversion = '';
$lastversion = `cat /var/log/copfilter/default/opt/privoxy/var/log/privoxy/LASTVERSION`;
my $privoxyver = system ('/bin/grep "*** Version 3.0.20" /var/log/copfilter/default/opt/privoxy/default/share/doc/privoxy/ChangeLog &>/dev/null 2>&1');
my $privoxymodA = system ('/bin/grep "configure_action_files" /var/log/copfilter/default/opt/privoxy/etc/init.d/copfilter_privoxy &>/dev/null 2>&1');
my $privoxymodB = system ('/bin/grep "COMPLETE_RULES10" /var/log/copfilter/default/opt/privoxy/etc/init.d/copfilter_privoxy &>/dev/null 2>&1');
my $privoxymodC = system ('/bin/grep "COMPLETE_RULES13" /var/log/copfilter/default/opt/privoxy/etc/init.d/copfilter_privoxy &>/dev/null 2>&1');
my $privoxymodD = system ('/bin/grep "DNS_FILTERING" /var/log/copfilter/default/opt/privoxy/etc/init.d/copfilter_privoxy &>/dev/null 2>&1');




require '/var/ipcop/general-functions.pl';
require "${General::swroot}/lang.pl";
require "${General::swroot}/header.pl";

my ($copfilter_swroot);
my %copfiltersettings=();
my %netsettings=();
my (%selected,%checked)=();
my $errormessage = '';
my $output = '';
my $databases = '';
my $line;
my @temp;

$copfiltersettings{'ACTION'} = '';
$copfilter_swroot = '/var/log/copfilter/default';
&General::readhash("${General::swroot}/ethernet/settings", \%netsettings);
&General::readhash("${copfilter_swroot}/etc/global_settings", \%copfiltersettings);
#&General::writehash("/tmp/before_cgi", \%copfiltersettings);
$copfiltersettings{'SKIP_RESTART'}='off';
&Header::getcgihash(\%copfiltersettings);

#testing
#my %copfiltersettings2=();
#&General::readhash("${copfilter_swroot}/etc/global_settings", \%copfiltersettings3);
#&Header::getcgihash(\%copfiltersettings2);
#&General::writehash("/tmp/after_cgi", \%copfiltersettings);
#&General::writehash("/tmp/cgi", \%copfiltersettings2);


&Header::showhttpheaders();
&Header::openpage('Copfilter', 1, '');


#sub copfilter_set_lang {

package Lang;

### Initialize language
%Lang::tr = ();
    our $language;
    my %settings = ();
    &General::readhash("${General::swroot}/main/settings", \%settings);
    $language = $settings{'LANGUAGE'};
    if ($language =~ /^(\w+)$/) {$language = $1;}
    do "${copfilter_swroot}/langs/en.pl";
    do "${copfilter_swroot}/langs/${language}.pl";
1;
#}
#
#copfilter_set_lang();

my $statusupdate = '';
my $CUR_VER = '';
my $CUR_MAIN = 0;
my $CUR_SUB1 = 0;
my $CUR_SUB2 = 0;
my $NEW_VER = '';
my $NEW_MAIN = 0;
my $NEW_SUB1 = 0;
my $NEW_SUB2 = 0;
my $UPDATE = 0;
my $THRDP = 0;


if ( system ("grep RULES_VERSION= ${copfilter_swroot}/etc/global_settings >/dev/null 2>&1") eq 0 ){
$THRDP = 1;
$CUR_VER = `echo $copfiltersettings{'RULES_VERSION'} | cut -d "b" -f1`;

if ( -e "${copfilter_swroot}/opt/privoxy/var/log/privoxy/LASTVERSION" ){
	$NEW_VER = `cat "${copfilter_swroot}/opt/privoxy/var/log/privoxy/LASTVERSION" | cut -d "b" -f1`;
}else{
	$NEW_VER = $CUR_VER;
}

$CUR_MAIN = `echo '$CUR_VER' | cut -d "." -f1`;
$CUR_SUB1 = `echo '$CUR_VER' | cut -d "." -f2`;
$CUR_SUB2 = `echo '$CUR_VER' | cut -d "." -f3`;

$NEW_MAIN = `echo '$NEW_VER' | cut -d "." -f1`;
$NEW_SUB1 = `echo '$NEW_VER' | cut -d "." -f2`;
$NEW_SUB2 = `echo '$NEW_VER' | cut -d "." -f3`;

if ( $NEW_MAIN eq $CUR_MAIN ){
	if ( $NEW_SUB1 eq $CUR_SUB1 ){
		if ( $NEW_SUB2 gt $CUR_SUB2 ){
			$UPDATE = 1;
		}
	}elsif ( $NEW_SUB1 gt $CUR_SUB1 ){
		$UPDATE = 1;
	}
}elsif ( $NEW_MAIN gt $CUR_MAIN ){
	$UPDATE = 1;
}
}else{
if ( system ("grep RULES_DISPLAY= ${copfilter_swroot}/etc/global_settings >/dev/null 2>&1") eq 0 ){
system('cat /var/log/copfilter/default/etc/global_settings | sed "s/^RULES_DISPLAY=.*$/RULES_DISPLAY=off/" > /tmp/global_settings');
system('chown nobody.nobody /tmp/global_settings');
system('mv -f /tmp/global_settings /var/log/copfilter/default/etc/global_settings');
}else{
system("echo 'RULES_DISPLAY=off' >> /var/log/copfilter/default/etc/global_settings");
}
}


################################################################################
##   Substitutions
################################################################################


sub copfilter_start_log
{

	&Header::openbigbox('100%', 'left');
	&Header::openbox('100%', 'left', "$Lang::tr{'copfilter'}:");
	print "<H1>  $Lang::tr{'copfilter log'}: </H1>\n";
}

sub copfilter_stop_log
{
        print "<br /><br />";
        #system('echo "<A HREF=$HTTP_REFERER> Back to the copfilter configuration page </A>"');
        print "<A HREF='/cgi-bin/copfilter_http.cgi' > $Lang::tr{'copfilter back'} </A>\n";
        print "<br /><br />";

        &Header::closebox();
        &Header::closebigbox();
        &Header::closepage();
}


sub writehashsorted
{
        my $filename = $_[0];
        my $hash = $_[1];
        my ($var, $val);


        # write cgi vars to the file.
        open(FILE, ">${filename}") or die "Unable to write file $filename";
        flock FILE, 2;
        foreach $var (sort (keys %$hash))
        {
                $val = $hash->{$var};
                # Darren Critchley Jan 17, 2003 added the following because when submitting with a graphic, the x and y
                # location of the mouse are submitted as well, this was being written to the settings file causing
                # some serious grief! This skips the variable.x and variable.y
                if (!($var =~ /(.x|.y)$/)) {
                        if ($val =~ / /) {
                                $val = "\'$val\'"; }
                        if (!($var =~ /^ACTION/)) {
                                print FILE "${var}=${val}\n"; }
                }
        }
        close FILE;
}


sub downloadver
{
        my %proxysettings=();
        &General::readhash("${General::swroot}/proxy/settings", \%proxysettings);

        my $peer = 'www.copfilter.org';
        my $peerport = 80;

        if ($_=$proxysettings{'UPSTREAM_PROXY'}) {
        ($peer, $peerport) = (/^(?:[a-zA-Z ]+\:\/\/)?(?:[A-Za-z0-9\_\.\-]*?(?:\:[A-Za-z0-9\_\.\-]*?)?\@)?([a-zA-Z0-9\.\_\-]*?)(?:\:([0-9]{1,5}))?(?:\/.*?)?$/);
        }

        my $sock=();
        unless($sock = new IO::Socket::INET (PeerAddr => $peer, PeerPort => $peerport, Proto => 'tcp', Timeout => 5))
        {
                return 0;
        }


        my $GET_CMD;
        $GET_CMD  = "GET http://www.copfilter.org/LATEST-VERSION HTTP/1.1\r\n";
        $GET_CMD .= "Host: www.copfilter.org\r\n";
        $GET_CMD .= "Cache-Control: no-cache\r\n";
        $GET_CMD .= "Connection: close\r\n\r\n";
        print $sock "$GET_CMD";

        my $ret = '';
        while (<$sock>) {
                $ret .= $_; }
        close($sock);
        return $ret;
}







################################################################################
##   HTTP
################################################################################

######### PRIVOXY_ENABLE
$selected{'PRIVOXY_ENABLE'}{'off'} = '';
$selected{'PRIVOXY_ENABLE'}{'on'} = '';
$selected{'PRIVOXY_ENABLE'}{$copfiltersettings{'PRIVOXY_ENABLE'}} = "selected='selected'";
#
######## BASIC RULES ENABLE
$selected{'BASIC_RULES'}{'off'} = '';
$selected{'BASIC_RULES'}{'on'} = '';
$selected{'BASIC_RULES'}{$copfiltersettings{'BASIC_RULES'}} = "selected='selected'";
#
######## COMPLETE_RULES  ENABLE
$selected{'COMPLETE_RULES'}{'off'} = '';
$selected{'COMPLETE_RULES'}{'on'} = '';
$selected{'COMPLETE_RULES'}{$copfiltersettings{'COMPLETE_RULES'}} = "selected='selected'";
#
######## RULES  DISPLAY
$selected{'RULES_DISPLAY'}{'off'} = '';
$selected{'RULES_DISPLAY'}{'on'} = '';
$selected{'RULES_DISPLAY'}{$copfiltersettings{'RULES_DISPLAY'}} = "selected='selected'";
#
######## COMPLETE_RULES1  ENABLE
$selected{'COMPLETE_RULES1'}{'off'} = '';
$selected{'COMPLETE_RULES1'}{'on'} = '';
$selected{'COMPLETE_RULES1'}{$copfiltersettings{'COMPLETE_RULES1'}} = "selected='selected'";
#
######## COMPLETE_RULES2  ENABLE
$selected{'COMPLETE_RULES2'}{'off'} = '';
$selected{'COMPLETE_RULES2'}{'on'} = '';
$selected{'COMPLETE_RULES2'}{$copfiltersettings{'COMPLETE_RULES2'}} = "selected='selected'";
#
######## COMPLETE_RULES3  ENABLE
$selected{'COMPLETE_RULES3'}{'off'} = '';
$selected{'COMPLETE_RULES3'}{'on'} = '';
$selected{'COMPLETE_RULES3'}{$copfiltersettings{'COMPLETE_RULES3'}} = "selected='selected'";
#
######## COMPLETE_RULES4  ENABLE
$selected{'COMPLETE_RULES4'}{'off'} = '';
$selected{'COMPLETE_RULES4'}{'on'} = '';
$selected{'COMPLETE_RULES4'}{$copfiltersettings{'COMPLETE_RULES4'}} = "selected='selected'";
#
######## COMPLETE_RULES5  ENABLE
$selected{'COMPLETE_RULES5'}{'off'} = '';
$selected{'COMPLETE_RULES5'}{'on'} = '';
$selected{'COMPLETE_RULES5'}{$copfiltersettings{'COMPLETE_RULES5'}} = "selected='selected'";
#
######## COMPLETE_RULES6  ENABLE
$selected{'COMPLETE_RULES6'}{'off'} = '';
$selected{'COMPLETE_RULES6'}{'on'} = '';
$selected{'COMPLETE_RULES6'}{$copfiltersettings{'COMPLETE_RULES6'}} = "selected='selected'";
#
######## COMPLETE_RULES7  ENABLE
$selected{'COMPLETE_RULES7'}{'off'} = '';
$selected{'COMPLETE_RULES7'}{'on'} = '';
$selected{'COMPLETE_RULES7'}{$copfiltersettings{'COMPLETE_RULES7'}} = "selected='selected'";
#
######## COMPLETE_RULES8  ENABLE
$selected{'COMPLETE_RULES8'}{'off'} = '';
$selected{'COMPLETE_RULES8'}{'on'} = '';
$selected{'COMPLETE_RULES8'}{$copfiltersettings{'COMPLETE_RULES8'}} = "selected='selected'";
#
######## COMPLETE_RULES9  ENABLE
$selected{'COMPLETE_RULES9'}{'off'} = '';
$selected{'COMPLETE_RULES9'}{'on'} = '';
$selected{'COMPLETE_RULES9'}{$copfiltersettings{'COMPLETE_RULES9'}} = "selected='selected'";
#
######## COMPLETE_RULES10  ENABLE
$selected{'COMPLETE_RULES10'}{'off'} = '';
$selected{'COMPLETE_RULES10'}{'on'} = '';
$selected{'COMPLETE_RULES10'}{$copfiltersettings{'COMPLETE_RULES10'}} = "selected='selected'";
#
######## COMPLETE_RULES11  ENABLE
$selected{'COMPLETE_RULES11'}{'off'} = '';
$selected{'COMPLETE_RULES11'}{'on'} = '';
$selected{'COMPLETE_RULES11'}{$copfiltersettings{'COMPLETE_RULES11'}} = "selected='selected'";
#
######## COMPLETE_RULES12  ENABLE
$selected{'COMPLETE_RULES12'}{'off'} = '';
$selected{'COMPLETE_RULES12'}{'on'} = '';
$selected{'COMPLETE_RULES12'}{$copfiltersettings{'COMPLETE_RULES12'}} = "selected='selected'";
#
######## COMPLETE_RULES13  ENABLE
$selected{'COMPLETE_RULES13'}{'off'} = '';
$selected{'COMPLETE_RULES13'}{'on'} = '';
$selected{'COMPLETE_RULES13'}{$copfiltersettings{'COMPLETE_RULES13'}} = "selected='selected'";
#
######## COMPLETE_RULES14  ENABLE
$selected{'COMPLETE_RULES14'}{'off'} = '';
$selected{'COMPLETE_RULES14'}{'on'} = '';
$selected{'COMPLETE_RULES14'}{$copfiltersettings{'COMPLETE_RULES14'}} = "selected='selected'";
#
######## PRIVOXY_MAIL_NOTIF  ENABLE
$selected{'PRIVOXY_MAIL_NOTIF'}{'off'} = '';
$selected{'PRIVOXY_MAIL_NOTIF'}{'on'} = '';
$selected{'PRIVOXY_MAIL_NOTIF'}{$copfiltersettings{'PRIVOXY_MAIL_NOTIF'}} = "selected='selected'";
#
######### PRIVOXY_UPDATE_METHOD
$selected{'PRIVOXY_UPDATE_METHOD'}{'manually'} = '';
$selected{'PRIVOXY_UPDATE_METHOD'}{'periodically'} = '';
$selected{'PRIVOXY_UPDATE_METHOD'}{$copfiltersettings{'PRIVOXY_UPDATE_METHOD'}} = "checked='checked'";
#
######## PRIVOXY_UPDATE_PERIOD
$selected{'PRIVOXY_UPDATE_PERIOD'}{'minutely'} = '';
$selected{'PRIVOXY_UPDATE_PERIOD'}{'hourly'} = '';
$selected{'PRIVOXY_UPDATE_PERIOD'}{'daily'} = '';
$selected{'PRIVOXY_UPDATE_PERIOD'}{'weekly'} = '';
$selected{'PRIVOXY_UPDATE_PERIOD'}{'monthly'} = '';
$selected{'PRIVOXY_UPDATE_PERIOD'}{$copfiltersettings{'PRIVOXY_UPDATE_PERIOD'}} = "selected='selected'";
#
######## DNS FILTERING ENABLE
$selected{'DNS_FILTERING'}{'default'} = '';
$selected{'DNS_FILTERING'}{'Comodo SecureDNS'} = '';
$selected{'DNS_FILTERING'}{'Norton ConnectSafe 1'} = '';
$selected{'DNS_FILTERING'}{'Norton ConnectSafe 2'} = '';
$selected{'DNS_FILTERING'}{'OpenDNS'} = '';
$selected{'DNS_FILTERING'}{$copfiltersettings{'DNS_FILTERING'}} = "selected='selected'";
#
########## HTTP_SCAN_GREEN
#$selected{'HTTP_SCAN_GREEN'}{'off'} = '';
#$selected{'HTTP_SCAN_GREEN'}{'on'} = '';
#$selected{'HTTP_SCAN_GREEN'}{$copfiltersettings{'HTTP_SCAN_GREEN'}} = "selected='selected'";
#
########## HTTP_SCAN_ORANGE
#$selected{'HTTP_SCAN_ORANGE'}{'off'} = '';
#$selected{'HTTP_SCAN_ORANGE'}{'on'} = '';
#$selected{'HTTP_SCAN_ORANGE'}{$copfiltersettings{'HTTP_SCAN_ORANGE'}} = "selected='selected'";
#
########## HTTP_SCAN_BLUE
#$selected{'HTTP_SCAN_BLUE'}{'off'} = '';
#$selected{'HTTP_SCAN_BLUE'}{'on'} = '';
#$selected{'HTTP_SCAN_BLUE'}{$copfiltersettings{'HTTP_SCAN_BLUE'}} = "selected='selected'";

######### HTTP_VIRUS_SCAN
$selected{'HTTP_VIRUS_SCAN'}{'off'} = '';
$selected{'HTTP_VIRUS_SCAN'}{'on'} = '';
$selected{'HTTP_VIRUS_SCAN'}{$copfiltersettings{'HTTP_VIRUS_SCAN'}} = "selected='selected'";

######### HTTP_VIRUS_SCAN_TRANSPARENT
$selected{'HTTP_VIRUS_SCAN_TRANSPARENT'}{'off'} = '';
$selected{'HTTP_VIRUS_SCAN_TRANSPARENT'}{'on'} = '';
$selected{'HTTP_VIRUS_SCAN_TRANSPARENT'}{$copfiltersettings{'HTTP_VIRUS_SCAN_TRANSPARENT'}} = "selected='selected'";

######### HAVP_RAMFS
$selected{'HAVP_RAMFS'}{'off'} = '';
$selected{'HAVP_RAMFS'}{'on'} = '';
$selected{'HAVP_RAMFS'}{$copfiltersettings{'HAVP_RAMFS'}} = "selected='selected'";

######### HTTP_VIRUS_SCAN_CLAMAV
$selected{'HTTP_VIRUS_SCAN_CLAMAV'}{'off'} = '';
$selected{'HTTP_VIRUS_SCAN_CLAMAV'}{'on'} = '';
$selected{'HTTP_VIRUS_SCAN_CLAMAV'}{$copfiltersettings{'HTTP_VIRUS_SCAN_CLAMAV'}} = "selected='selected'";

######### HTTP_CLAMAV_LIBRARY
$selected{'HTTP_CLAMAV_LIBRARY'}{'off'} = '';
$selected{'HTTP_CLAMAV_LIBRARY'}{'on'} = '';
$selected{'HTTP_CLAMAV_LIBRARY'}{$copfiltersettings{'HTTP_CLAMAV_LIBRARY'}} = "selected='selected'";

######### HTTP_VIRUS_SCAN_FPROT
$selected{'HTTP_VIRUS_SCAN_FPROT'}{'off'} = '';
$selected{'HTTP_VIRUS_SCAN_FPROT'}{'on'} = '';
$selected{'HTTP_VIRUS_SCAN_FPROT'}{$copfiltersettings{'HTTP_VIRUS_SCAN_FPROT'}} = "selected='selected'";

######### HTTP_VIRUS_SCAN_AVG
$selected{'HTTP_VIRUS_SCAN_AVG'}{'off'} = '';
$selected{'HTTP_VIRUS_SCAN_AVG'}{'on'} = '';
$selected{'HTTP_VIRUS_SCAN_AVG'}{$copfiltersettings{'HTTP_VIRUS_SCAN_AVG'}} = "selected='selected'";


################################################################################
##   ACTIONs
################################################################################

########## Manually update for Privoxy rules
if ($copfiltersettings{'ACTION'} eq $Lang::tr{'copfilter privoxy update now'})
{
     	 system ('/bin/touch', "/var/log/copfilter/default/etc/copfilter_check-updates_privoxy.done");
        system ('/bin/touch', "/tmp/copfilter_check-updates_privoxy.done");
        $copfiltersettings{'ACTION'} = '';
}



######### Save settings

if ($copfiltersettings{'ACTION'} eq $Lang::tr{'copfilter save'})
{ 

################################################################################
##   Checking input values
################################################################################
#########################################3rdp privoxy rules #################################
if ( $privoxymodA eq 0){

	if ($copfiltersettings{'BASIC_RULES'} !~ /^(on|off)$/ || 
	    $copfiltersettings{'RULES_DISPLAY'} !~ /^(on|off)$/ ||
	    $copfiltersettings{'COMPLETE_RULES'} !~ /^(on|off)$/ ||
	    $copfiltersettings{'COMPLETE_RULES1'} !~ /^(on|off)$/ ||
	    $copfiltersettings{'COMPLETE_RULES2'} !~ /^(on|off)$/ ||
	    $copfiltersettings{'COMPLETE_RULES3'} !~ /^(on|off)$/ ||
	    $copfiltersettings{'COMPLETE_RULES4'} !~ /^(on|off)$/ ||
	    $copfiltersettings{'COMPLETE_RULES5'} !~ /^(on|off)$/ )
        {
		$errormessage = $Lang::tr{'copfilter invalid input'};
		goto ERROR;
	} 

}

if ( $privoxymodB eq 0 && $privoxyver eq 0 ){

	if ($copfiltersettings{'COMPLETE_RULES6'} !~ /^(on|off)$/ ||
	    $copfiltersettings{'COMPLETE_RULES7'} !~ /^(on|off)$/ ||
	    $copfiltersettings{'COMPLETE_RULES8'} !~ /^(on|off)$/ ||
	    $copfiltersettings{'COMPLETE_RULES9'} !~ /^(on|off)$/ ||
	    $copfiltersettings{'COMPLETE_RULES10'} !~ /^(on|off)$/ ||
	    $copfiltersettings{'COMPLETE_RULES11'} !~ /^(on|off)$/ ||
	    $copfiltersettings{'COMPLETE_RULES12'} !~ /^(on|off)$/ )
        {
		$errormessage = $Lang::tr{'copfilter invalid input'};
		goto ERROR;
	} 

}

if ( $privoxymodC eq 0 && $privoxyver eq 0 ){

	if ($copfiltersettings{'COMPLETE_RULES13'} !~ /^(on|off)$/ ||
	    $copfiltersettings{'COMPLETE_RULES14'} !~ /^(on|off)$/ ||
	    $copfiltersettings{'PRIVOXY_MAIL_NOTIF'} !~ /^(on|off)$/ )

        {
		$errormessage = $Lang::tr{'copfilter invalid input'};
		goto ERROR;
	} 

}


if ( $privoxymodD eq 0 ){

	if ($copfiltersettings{'DNS_FILTERING'} !~ /^(default|Comodo SecureDNS|Norton ConnectSafe 1|Norton ConnectSafe 2|OpenDNS)$/ )
        {
		$errormessage = $Lang::tr{'copfilter invalid input'};
		goto ERROR;
	} 

}





###########################################################################
	if ($copfiltersettings{'POP3_SCAN_GREEN'} !~ /^(on|off)$/ || 
	    $copfiltersettings{'POP3_SCAN_ORANGE'} !~ /^(on|off)$/ || 
	    $copfiltersettings{'POP3_SCAN_BLUE'} !~ /^(on|off)$/ || 
	    $copfiltersettings{'POP3_VIRUS_SCAN'} !~ /^(on|off)$/ || 
	    $copfiltersettings{'POP3_SPAM_QUARANTINE'} !~ /^(on|off)$/ || 
	    $copfiltersettings{'POP3_VIRUS_QUARANTINE'} !~ /^(on|off)$/ || 
	    $copfiltersettings{'POP3_ATTACHMENT_SCAN'} !~ /^(on|off)$/ || 
	    $copfiltersettings{'POP3_SPAM_SCAN'} !~ /^(on|off)$/ || 
	    $copfiltersettings{'POP3_SANITIZE_SCAN'} !~ /^(on|off)$/ || 
	    $copfiltersettings{'POP3_MAIL_REWRITE_SUBJECT'} !~ /^(on|off)$/ || 
	    $copfiltersettings{'POP3_MAIL_ADD_HEADER'} !~ /^(on|off)$/ || 
	    $copfiltersettings{'POP3_MAIL_ADD_BODY'} !~ /^(on|off)$/ || 
	    $copfiltersettings{'POP3_VIRUS_ADMINNOTIF'} !~ /^(on|off)$/ || 
	    $copfiltersettings{'SMTP_SCAN_GREEN'} !~ /^(on|off)$/ || 
	    $copfiltersettings{'SMTP_SCAN_ORANGE'} !~ /^(on|off)$/ || 
	    $copfiltersettings{'SMTP_SCAN_BLUE'} !~ /^(on|off)$/ || 
	    $copfiltersettings{'SMTP_SCAN_RED'} !~ /^(on|off)$/ || 
	    $copfiltersettings{'SMTP_VIRUS_SCAN'} !~ /^(on|off)$/ || 
	    $copfiltersettings{'SMTP_SPAM_QUARANTINE'} !~ /^(on|off)$/ || 
	    $copfiltersettings{'SMTP_VIRUS_QUARANTINE'} !~ /^(on|off)$/ || 
	    $copfiltersettings{'SMTP_SPAM_QUARANTINE_NOTIFY_USER'} !~ /^(on|off)$/ || 
	    $copfiltersettings{'SMTP_VIRUS_NOTIFY_USER'} !~ /^(on|off)$/ || 
#	    $copfiltersettings{'SMTP_VIRUS_SCAN_BOUNCE'} !~ /^(on|off)$/ || 
	    $copfiltersettings{'SMTP_VIRUS_SCAN_DISCARD'} !~ /^(on|off)$/ || 
	    $copfiltersettings{'SMTP_ATTACHMENT_SCAN'} !~ /^(on|off)$/ || 
#	    $copfiltersettings{'SMTP_ATTACHMENT_SCAN_BOUNCE'} !~ /^(on|off)$/ || 
	    $copfiltersettings{'SMTP_ATTACHMENT_SCAN_DISCARD'} !~ /^(on|off)$/ || 
	    $copfiltersettings{'SMTP_SPAM_SCAN'} !~ /^(on|off)$/ || 
#	    $copfiltersettings{'SMTP_SPAM_SCAN_BOUNCE'} !~ /^(on|off)$/ || 
	    $copfiltersettings{'SMTP_SPAM_SCAN_DISCARD'} !~ /^(on|off)$/ || 
	    $copfiltersettings{'SMTP_SANITIZE_SCAN'} !~ /^(on|off)$/ || 
	    $copfiltersettings{'SMTP_AUTH_ENABLE'} !~ /^(on|off)$/ || 
	    $copfiltersettings{'IMAP_ENABLE'} !~ /^(on|off)$/ || 
	    $copfiltersettings{'IMAP_DEBUG'} !~ /^(on|off)$/ || 
	    $copfiltersettings{'IMAP_DAILY'} !~ /^(on|off)$/ || 
	    $copfiltersettings{'SMTP_MAIL_REWRITE_SUBJECT'} !~ /^(on|off)$/ || 
	    $copfiltersettings{'SMTP_MAIL_ADD_HEADER'} !~ /^(on|off)$/ || 
	    $copfiltersettings{'SMTP_MAIL_ADD_BODY'} !~ /^(on|off)$/ || 
	    $copfiltersettings{'SMTP_VIRUS_ADMINNOTIF'} !~ /^(on|off)$/ || 
	    $copfiltersettings{'SPAM_SCAN_SPEEDUP'} !~ /^(on|off)$/ || 
	    $copfiltersettings{'PRIVOXY_ENABLE'} !~ /^(on|off)$/ ||
#	    $copfiltersettings{'HTTP_SCAN_GREEN'} !~ /^(on|off)$/ || 
#	    $copfiltersettings{'HTTP_SCAN_ORANGE'} !~ /^(on|off)$/ || 
#	    $copfiltersettings{'HTTP_SCAN_BLUE'} !~ /^(on|off)$/ || 
	    $copfiltersettings{'HTTP_VIRUS_SCAN'} !~ /^(on|off)$/ || 
	    $copfiltersettings{'HAVP_RAMFS'} !~ /^(on|off)$/ || 
	    $copfiltersettings{'MONIT_ENABLE'} !~ /^(on|off)$/ || 
	    $copfiltersettings{'FTP_SCAN_GREEN'} !~ /^(on|off)$/ || 
	    $copfiltersettings{'FTP_SCAN_ORANGE'} !~ /^(on|off)$/ || 
	    $copfiltersettings{'FTP_SCAN_BLUE'} !~ /^(on|off)$/ || 
	    $copfiltersettings{'CLAMD_ENABLE'} !~ /^(on|off)$/ || 
	    $copfiltersettings{'HTTP_VIRUS_SCAN_CLAMAV'} !~ /^(on|off)$/ || 
	    $copfiltersettings{'HTTP_CLAMAV_LIBRARY'} !~ /^(on|off)$/ || 
	    $copfiltersettings{'HTTP_VIRUS_SCAN_FPROT'} !~ /^(on|off)$/ || 
	    $copfiltersettings{'HTTP_VIRUS_SCAN_AVG'} !~ /^(on|off)$/ || 
	    $copfiltersettings{'FPROT_ENABLE'} !~ /^(on|off)$/ ) 
        {
		$errormessage = $Lang::tr{'copfilter invalid input'};
		goto ERROR;
	} 


        if ( $copfiltersettings{'PRIVOXY_ENABLE'} eq 'on' && $copfiltersettings{'HTTP_VIRUS_SCAN'} eq 'off')
        {
                $errormessage = $Lang::tr{'copfilter enable havp'};
                goto ERROR;
        }
      
        if ( $copfiltersettings{'HTTP_VIRUS_SCAN'} eq 'on' && $copfiltersettings{'HTTP_VIRUS_SCAN_CLAMAV'} eq 'off' && $copfiltersettings{'HTTP_VIRUS_SCAN_FPROT'} eq 'off'  && $copfiltersettings{'HTTP_VIRUS_SCAN_AVG'} eq 'off')
        {
                $errormessage = $Lang::tr{'copfilter http_all_off'};
                goto ERROR;
        }
      

	if (!($copfiltersettings{'PRIVOXY_UPDATE_VALUE'} =~ /^\d+$/) || $copfiltersettings{'PRIVOXY_UPDATE_VALUE'} <= 0)
        {
                $errormessage = $Lang::tr{'copfilter invalid privoxy time period'};
                goto ERROR;
        }



ERROR:
	if ($errormessage) {
		$copfiltersettings{'VALID'} = 'no'; }
	else {
              	$copfiltersettings{'VALID'} = 'yes'; }




################################################################################
##   set update values
################################################################################


        # PRIVOXY
        my ($privoxy_updateperiod)=();

        if  ($copfiltersettings{'PRIVOXY_UPDATE_PERIOD'} eq 'hourly') {
        	$privoxy_updateperiod = $copfiltersettings{'PRIVOXY_UPDATE_VALUE'} * 60; }
        elsif  ($copfiltersettings{'PRIVOXY_UPDATE_PERIOD'} eq 'daily') {
        	$privoxy_updateperiod = $copfiltersettings{'PRIVOXY_UPDATE_VALUE'} * 1440; }
        elsif  ($copfiltersettings{'PRIVOXY_UPDATE_PERIOD'} eq 'weekly') {
        	$privoxy_updateperiod = $copfiltersettings{'PRIVOXY_UPDATE_VALUE'} * 10080; }
        elsif  ($copfiltersettings{'PRIVOXY_UPDATE_PERIOD'} eq 'monthly') {
        	$privoxy_updateperiod = $copfiltersettings{'PRIVOXY_UPDATE_VALUE'} * 40320; }
        

        $privoxy_updateperiod = $privoxy_updateperiod - 5;

        if ($privoxy_updateperiod <= 5) {
        	$privoxy_updateperiod = 5; }

        open(FILE, ">/${copfilter_swroot}/etc/privoxy_counter.conf") or die $Lang::tr{'copfilter privoxy_counter'};
        flock(FILE, 2);
        print FILE "$privoxy_updateperiod\n";
        close FILE;



################################################################################
##   purge enable and update files
################################################################################



	if ($copfiltersettings{'VALID'} eq 'yes')
	{

	    unlink "${copfilter_swroot}/etc/havp_enable";
	    unlink "${copfilter_swroot}/etc/privoxy_enable";
        if ( $copfiltersettings{'HTTP_VIRUS_SCAN'} eq 'on' ) {
		    system ('touch', "${copfilter_swroot}/etc/havp_enable"); }
	    if ($copfiltersettings{'PRIVOXY_ENABLE'} eq 'on') {
		    system ('touch', "${copfilter_swroot}/etc/privoxy_enable"); }


	if ( ! -e "${copfilter_swroot}/etc/privoxy_counter") {
                if ($copfiltersettings{'PRIVOXY_UPDATE_METHOD'} eq 'periodically')
                {
                        open(FILE, ">/${copfilter_swroot}/etc/privoxy_counter") or die "Unable to write privoxy_counter file";
                        flock(FILE, 2);
                        print FILE "$privoxy_updateperiod\n";
                        close FILE;
                }
           }


# if setting were valid, write settings and reconfigure




    ################################### update white and blacklist for HAVP ##############"
    @temp = split(/\n/,$copfiltersettings{'HAVP_AVSCAN_EXCT'});
    undef $copfiltersettings{'HAVP_AVSCAN_EXCT'};
    foreach (@temp)
    {
        s/^\s+//g; s/\s+$//g;
        if ($_)
        {
            $line = $_;
            $line =~ /[a-zA-Z0-9][a-zA-Z0-9_.-]*/;
            $copfiltersettings{'HAVP_AVSCAN_EXCT'} .= $line."\n";
        }
    }

     open(FILE, ">/var/log/copfilter/default/opt/havp/etc/blacklist");
 
       flock(FILE, 2);
       print (FILE "$copfiltersettings{'HAVP_AVSCAN_EXCT'}");
       close (FILE);
       delete $copfiltersettings{'HAVP_AVSCAN_EXCT'};

    @temp = split(/\n/,$copfiltersettings{'HAVP_AVSCAN_WHITELIST'});
    undef $copfiltersettings{'HAVP_AVSCAN_WHITELIST'};
    foreach (@temp)
    {
        s/^\s+//g; s/\s+$//g;
        if ($_)
        {
            $line = $_;
            $line =~ /[a-zA-Z0-9][a-zA-Z0-9_.-]*/;
            $copfiltersettings{'HAVP_AVSCAN_WHITELIST'} .= $line."\n";
        }
    }

     open(FILE, ">/var/log/copfilter/default/opt/havp/etc/whitelist");
 
       flock(FILE, 2);
       print (FILE "$copfiltersettings{'HAVP_AVSCAN_WHITELIST'}");
        close (FILE);
       delete $copfiltersettings{'HAVP_AVSCAN_WHITELIST'};
	##################################### end of update for HAVP black and whitellist ################



         &writehashsorted("${copfilter_swroot}/etc/global_settings", \%copfiltersettings);
        if ( ! ($copfiltersettings{'SKIP_RESTART'} eq 'on' )) {
            &copfilter_start_log(); 
            print "<br /><b>$Lang::tr{'copfilter restart0'} havp..</b> <br />";
            system('/usr/local/bin/copfilter_restarthavp');
            print "<br /><b>$Lang::tr{'copfilter restart0'} privoxy..</b> <br />";

            system('/usr/local/bin/copfilter_restartprivoxy');
            print "<br /><b>$Lang::tr{'copfilter restart0'} monit..</b> <br />";
            system('/usr/local/bin/copfilter_restartmonit');
            &copfilter_stop_log();
            &copfilter_stop_log(); 
        }
        else {
            $copfiltersettings{'ACTION'} = '';
        }


        }
        else {
            $copfiltersettings{'ACTION'} = '';
        }


}



################################################################################
##  Website - Information
################################################################################


#for testing purposes only
#&General::writehash("/tmp/settings", \%copfiltersettings);

if ($copfiltersettings{'ACTION'} eq '')
{

### For testing ###
#$errormessage = "This Page is not corrctly formatted!";

&Header::openbigbox('100%', 'left', '', $errormessage);


if ($errormessage) {
    &Header::openbox('100%', 'left', $Lang::tr{'copfilter error messages'});
    print "<class name='base'><font color='${Header::colourred}'>$errormessage\n</font>";
    print "&nbsp;</class>\n";
    &Header::closebox();
}


################################################################################
##  Website - HTTP Scanning
################################################################################
my $outputhavp = `/etc/rc.d/init.d/copfilter_havp pid weboutput`;
my $statushavp = "";
if ( $outputhavp =~ /OFF/ ) { $statushavp="<td nowrap height='20' bgcolor='#C01327' align='center' ><font color='#FFFFFF' size='2.7em'><b> STOPPED <\/b><\/font>"; }
if ( $outputhavp =~ /NOT ACTIVATED/ ) { $statushavp="<td nowrap height='20' bgcolor='#A8A8A8' align='center' ><font size='2.7em'><b> NOT ACTIVATED <\/b><\/font>";; }
if ( $outputhavp =~ /ON/ ) { $statushavp="<td nowrap height='20' bgcolor='#339933' align='center' ><font color='#FFFFFF' size='2.7em'><b> RUNNING <\/b><\/font>";; }

my $outputprivoxy = `/etc/rc.d/init.d/copfilter_privoxy pid weboutput`;
my $statusprivoxy = "";
if ( $outputprivoxy =~ /OFF/ ) { $statusprivoxy="<td nowrap height='20' bgcolor='#C01327' align='center' ><font color='#FFFFFF' size='2.7em'><b> STOPPED <\/b><\/font>"; }
if ( $outputprivoxy =~ /NOT ACTIVATED/ ) { $statusprivoxy="<td nowrap height='20' bgcolor='#A8A8A8' align='center' ><font size='2.7em'><b> NOT ACTIVATED <\/b><\/font>";; }
if ( $outputprivoxy =~ /ON/ ) { $statusprivoxy="<td nowrap height='20' bgcolor='#339933' align='center' ><font color='#FFFFFF' size='2.7em'><b> RUNNING <\/b><\/font>";; }

my $outputdns = `cat /var/log/copfilter/default/opt/dns/dns`;
my $statusdns = "";
if ( $outputdns =~ /default/ ) { $statusdns="<td nowrap height='20' bgcolor='#A8A8A8' align='center' ><font size='2.7em'><b> NOT ACTIVATED <\/b><\/font>";; }
if ( $outputdns =~ /SecureDNS/ ) { $statusdns="<td nowrap height='20' bgcolor='#339933' align='center' ><font color='#FFFFFF' size='2.7em'><b> RUNNING <\/b><\/font>";; }
if ( $outputdns =~ /NORTON1/ ) { $statusdns="<td nowrap height='20' bgcolor='#339933' align='center' ><font color='#FFFFFF' size='2.7em'><b> RUNNING <\/b><\/font>";; }
if ( $outputdns =~ /NORTON2/ ) { $statusdns="<td nowrap height='20' bgcolor='#339933' align='center' ><font color='#FFFFFF' size='2.7em'><b> RUNNING <\/b><\/font>";; }
if ( $outputdns =~ /OPENDNS/ ) { $statusdns="<td nowrap height='20' bgcolor='#339933' align='center' ><font color='#FFFFFF' size='2.7em'><b> RUNNING <\/b><\/font>";; }

print "<a name='http'/>";
&Header::openbox('100%', 'left', "$Lang::tr{'copfilter http'} (HAVP, Privoxy):");
print "<form method='post' action='/cgi-bin/copfilter_http.cgi' enctype='multipart/form-data'>";
print <<END
<table width='100%' border='0' cellpadding='5'>
<tr>
	<td nowrap width='11%'></td>
	<td nowrap width='14%'></td>
	<td nowrap width='75%'></td>
</tr>
    <td nowrap><font size='2.7em'><b>HAVP Status:</b></td>
    $statushavp

<tr>
	<td nowrap colspan='2'></td>
</tr>
</table>
<table width='100%' border='0' cellpadding='5'>
<tr>
	<td nowrap width='11%'></td>
	<td nowrap width='14%'></td>
	<td nowrap width='3%'></td>
	<td nowrap width='3%'></td>
	<td nowrap width='19%'></td>
	<td nowrap width='11%'></td>
	<td nowrap width='14%'></td>
	<td nowrap width='3%'></td>
	<td nowrap width='3%'></td>
	<td nowrap width='19%'></td>
</tr>
END
;

    if ($copfiltersettings{'HTTP_VIRUS_SCAN'} !~ /^off$/) {
        $OPTCOL='#009C28'; }
    else {
        $OPTCOL='#C1C1C1'; }

print <<END
<tr>

        <td nowrap colspan='2'>$Lang::tr{'copfilter http_virscan'}</td>
        <td nowrap> <select name='HTTP_VIRUS_SCAN' style="border:2px solid $OPTCOL;">
             <option value='on' $selected{'HTTP_VIRUS_SCAN'}{'on'}>on</option>
             <option value='off' $selected{'HTTP_VIRUS_SCAN'}{'off'}>off</option> </select></td>
        <td nowrap> </td>

END
;


#<tr>
#END
#;
#if ($netsettings{'ORANGE_DEV'}) {
#print <<END
#        <td nowrap> $Lang::tr{'copfilter http_scan_orange'}</td>
#        <td nowrap> <select name='HTTP_SCAN_ORANGE' style="border:2px solid $OPTCOL;">
#             <option value='on' $selected{'HTTP_SCAN_ORANGE'}{'on'}>on</option>
#             <option value='off' $selected{'HTTP_SCAN_ORANGE'}{'off'}>off</option> </select></td>
#        <td nowrap> </td>
#END
#;
#}
#else {
#print <<END 
#        <td nowrap> </td>
#        <td nowrap> </td>
#END
#}
#print <<END
#	<td nowrap> </td>
#	<td nowrap> </td>
#	<td nowrap> </td>
#
#
#</tr>
#<tr>
#END
#;
#if ($netsettings{'BLUE_DEV'}) {
#print <<END
#        <td nowrap> $Lang::tr{'copfilter http_scan_blue'}</td>
#        <td nowrap> <select name='HTTP_SCAN_BLUE'>
#             <option value='on' $selected{'HTTP_SCAN_BLUE'}{'on'}>on</option>
#             <option value='off' $selected{'HTTP_SCAN_BLUE'}{'off'}>off</option> </select></td>
#END
#;
#}
#else {
#print "<td nowrap> </td>\n";
#print "<td nowrap> </td>\n";
#}
#print <<END
#	<td nowrap> </td>
#	<td nowrap> </td>
#</tr>

    if ($copfiltersettings{'HTTP_VIRUS_SCAN_TRANSPARENT'} !~ /^off$/) {
        $OPTCOL='#009C28'; }
    else {
        $OPTCOL='#C1C1C1'; }

print <<END
	<td nowrap></td>
        <td nowrap colspan='2'> $Lang::tr{'copfilter http_virscan_transparent'}</td>
        <td nowrap> <select name='HTTP_VIRUS_SCAN_TRANSPARENT' style="border:2px solid $OPTCOL;">
             <option value='on' $selected{'HTTP_VIRUS_SCAN_TRANSPARENT'}{'on'}>on</option>
             <option value='off' $selected{'HTTP_VIRUS_SCAN_TRANSPARENT'}{'off'}>off</option> </select></td>

</tr>
END
;
    if ($copfiltersettings{'HAVP_RAMFS'} !~ /^off$/) {
        $OPTCOL='#009C28'; }
    else {
        $OPTCOL='#C1C1C1'; }

print <<END
<tr>
        <td nowrap colspan='2'> $Lang::tr{'copfilter havp_ramfs'}</td>
        <td nowrap> <select name='HAVP_RAMFS' style="border:2px solid $OPTCOL;">
             <option value='on' $selected{'HAVP_RAMFS'}{'on'}>on</option>
             <option value='off' $selected{'HAVP_RAMFS'}{'off'}>off</option> </select></td>
</tr>
<tr>
	<td nowrap> &nbsp;</td>
</tr>

<tr>
	<td nowrap colspan='10'> $Lang::tr{'copfilter http3'}</td>

</tr>
<tr>
	<td nowrap> &nbsp;</td>
</tr>
END
;



    if ($copfiltersettings{'HTTP_VIRUS_SCAN_CLAMAV'} !~ /^off$/) {
        $OPTCOL='#009C28'; }
    else {
        $OPTCOL='#C1C1C1'; }

print <<END
<tr>
        <td nowrap colspan='2'> $Lang::tr{'copfilter http_clamav'}</td>
        <td nowrap> <select name='HTTP_VIRUS_SCAN_CLAMAV' style="border:2px solid $OPTCOL;">
             <option value='on' $selected{'HTTP_VIRUS_SCAN_CLAMAV'}{'on'}>on</option>
             <option value='off' $selected{'HTTP_VIRUS_SCAN_CLAMAV'}{'off'}>off</option> </select></td>
	<td nowrap></td>

END
;

if ($copfiltersettings{'HTTP_VIRUS_SCAN_CLAMAV'} =~ /^on$/) {

    if ($copfiltersettings{'HTTP_CLAMAV_LIBRARY'} !~ /^off$/) {
        $OPTCOL='#009C28'; }
    else {
        $OPTCOL='#C1C1C1'; }



print <<END
	<td nowrap></td>
        <td nowrap colspan='2'> $Lang::tr{'copfilter http_clamav_library'}</td>
        <td nowrap> <select name='HTTP_CLAMAV_LIBRARY' style="border:2px solid $OPTCOL;">
             <option value='on' $selected{'HTTP_CLAMAV_LIBRARY'}{'on'}>on</option>
             <option value='off' $selected{'HTTP_CLAMAV_LIBRARY'}{'off'}>off</option> </select></td>

	</tr>
END
;}else{
print <<END
	</tr>
END
;}



if ($copfiltersettings{'HTTP_CLAMAV_LIBRARY'} eq 'on' ) {
$databases = `ls --ignore=*.c?d ${copfilter_swroot}/opt/havp/virdb/`;
if ( ! $databases eq '' ){

print <<END
<tr>
	<td nowrap> &nbsp;</td>
</tr>
<tr>
	<td nowrap colspan='10'><b>$Lang::tr{'copfilter clamd thrdp_info7'}</b>$databases</td>
</tr>
<tr>
	<td nowrap> &nbsp;</td>
</tr>
END
;
}}

    if ($copfiltersettings{'HTTP_VIRUS_SCAN_AVG'} !~ /^off$/) {
        $OPTCOL='#009C28'; }
    else {
        $OPTCOL='#C1C1C1'; }

if ($copfiltersettings{'AVG_INSTALLED'} eq 'yes' ) {
if ( -e "${copfilter_swroot}/opt/avg/default/bin/avgscan") {
print <<END
<tr>
        <td nowrap colspan='2'> $Lang::tr{'copfilter http_avg'}</td>
<td nowrap> <select name='HTTP_VIRUS_SCAN_AVG' style="border:2px solid $OPTCOL;">
             <option value='on' $selected{'HTTP_VIRUS_SCAN_AVG'}{'on'}>on</option>
             <option value='off' $selected{'HTTP_VIRUS_SCAN_AVG'}{'off'}>off</option> </select></td>
	<td nowrap></td>
	<td nowrap></td>
	
END
;
}
else {
print <<END
<tr>
END
;
}}








    if ($copfiltersettings{'HTTP_VIRUS_SCAN_FPROT'} !~ /^off$/) {
        $OPTCOL='#009C28'; }
    else {
        $OPTCOL='#C1C1C1'; }


if ($copfiltersettings{'FPROT_INSTALLED'} eq 'yes' ) {
if ( -e "${copfilter_swroot}/opt/f-prot/default/fpscand" ) {
print <<END
			<td nowrap colspan='2'> $Lang::tr{'copfilter http_fprot'}</td>
			<td nowrap> <select name='HTTP_VIRUS_SCAN_FPROT' style="border:2px solid $OPTCOL;">
			<option value='on' $selected{'HTTP_VIRUS_SCAN_FPROT'}{'on'}>on</option>
			<option value='off' $selected{'HTTP_VIRUS_SCAN_FPROT'}{'off'}>off</option> </select></td>
		</tr>
END
;
}
else {
print <<END
	<td nowrap colspan='2'>$Lang::tr{'copfilter http_fprot_free_only'} </td>
			        <td nowrap colspan='2'> </td>
		</tr>
END
;
}
}





print <<END
<tr>
	<td nowrap colspan='4'> $Lang::tr{'copfilter havp_viruslog'}</td>
</tr>





<tr>
	<td> &nbsp;</td>
</tr>
</table>


<!--- AV-Scan Exceptions --->

<table border='0' cellpadding='5'>

<tr>
	<td width='11%'></td>
	<td width='14%'></td>
	<td width='3%'></td>
	<td width='10%'></td>
	<td width='8%'></td>
	<td width='19%'></td>
	<td width='10%'></td>
	<td width='3%'></td>
	<td width='3%'></td>
	<td width='19%'></td>
</tr>

        <td colspan='2'> $Lang::tr{'copfilter http_own_domainlist'}</td>
<td> &nbsp;</td>
<td> &nbsp;</td>
<td> &nbsp;</td>

   <td colspan='8'> $Lang::tr{'copfilter http_own_domainlistwhite'}</td>

<tr>


        <td colspan='2'><textarea name='HAVP_AVSCAN_EXCT' cols='64' rows='8' />
END
;


    
 if (-e "/var/log/copfilter/default/opt/havp/etc/blacklist") {
        open(FILE, "</var/log/copfilter/default/opt/havp/etc/blacklist");
        delete $copfiltersettings{'HAVP_AVSCAN_EXCT'};
        while (<FILE>) { $copfiltersettings{'HAVP_AVSCAN_EXCT'} .= $_ }
        close(FILE);
    }

       print $copfiltersettings{'HAVP_AVSCAN_EXCT'};



print <<END

</textarea></td>

<td> &nbsp;</td>
<td> &nbsp;</td>
<td> &nbsp;</td>





        <td colspan='2'><textarea name='HAVP_AVSCAN_WHITELIST' cols='64' rows='8' />
END
;


    
 if (-e "/var/log/copfilter/default/opt/havp/etc/whitelist") {
        open(FILE, "</var/log/copfilter/default/opt/havp/etc/whitelist");
        delete $copfiltersettings{'HAVP_AVSCAN_WHITELIST'};
        while (<FILE>) { $copfiltersettings{'HAVP_AVSCAN_WHITELIST'} .= $_ }
        close(FILE);
    }

       print $copfiltersettings{'HAVP_AVSCAN_WHITELIST'};

print <<END
</textarea></td>
        <td>\n</td>

END
;

print <<END

<tr>
	<td nowrap> &nbsp;</td>
</tr>
<tr>
	<td nowrap> &nbsp;</td>
</tr>


<table width='100%' border='0' cellpadding='5'>
<tr>
	<td nowrap width='11%'></td>
	<td nowrap width='14%'></td>
	<td nowrap width='75%'></td>
</tr>

    <td nowrap><font size='2.7em'><b>Privoxy Status:</b></td>
    $statusprivoxy
</tr>
<tr>
	<td nowrap></td>
</tr>
</table>
<table width='88%' border='0' cellpadding='5'>
<tr>
	<td nowrap width='11%'></td>
	<td nowrap width='14%'></td>
	<td nowrap width='3%'></td>
	<td nowrap width='3%'></td>
	<td nowrap width='19%'></td>
	<td nowrap width='11%'></td>
	<td nowrap width='14%'></td>
	<td nowrap width='3%'></td>
	<td nowrap width='3%'></td>
	<td nowrap width='19%'></td>
</tr>
<tr>

         <td nowrap colspan='10'> $Lang::tr{'copfilter http2'}</td>

</tr>

<tr>
             <td nowrap colspan='4'><a href='http://config.privoxy.org' target=_blank><u>privoxy configuration</u></a>&nbsp;  &nbsp;  &nbsp;
             <a href="javascript:void(window.open('http://config.privoxy.org/toggle?mini=y&amp;set=toggle','ijbstatus','height=100,resizable=yes,scrollbars=no,toolbar=no,location=no,directories=no,status=no,menubar=no,copyhistory=no').focus());"> <u>privoxy bookmarklet</u></a></td>
</tr>
END
;

    if ($copfiltersettings{'PRIVOXY_ENABLE'} !~ /^off$/) {
        $OPTCOL='#009C28'; }
    else {
        $OPTCOL='#C1C1C1'; }

print <<END
<tr>

        <td nowrap colspan='2'> $Lang::tr{'copfilter http_scan'} </td>
	<td nowrap><select name='PRIVOXY_ENABLE' style="border:2px solid $OPTCOL;">
		<option value='on' $selected{'PRIVOXY_ENABLE'}{'on'}>on</option>
		<option value='off' $selected{'PRIVOXY_ENABLE'}{'off'}>off</option> </select></td>

END
;

if ( $privoxymodA ne 0){
print <<END
</tr>
END
;

}else{

    if ($copfiltersettings{'RULES_DISPLAY'} !~ /^off$/) {
        $OPTCOL='#009C28'; }
    else {
        $OPTCOL='#C1C1C1'; }

if ( $UPDATE eq 1 ) {
$statusupdate="<font color='#C01327'><b> $Lang::tr{'copfilter clamd thrdp_info11'} VERSION $NEW_VER $Lang::tr{'copfilter clamd thrdp_info12'} </b></font>"; }
else { $statusupdate='';}


print <<END
	<td nowrap colspan='2'></td>
        <td nowrap colspan='2'> $Lang::tr{'copfilter clamd thrdp_gui'} </td>
	<td nowrap><select name='RULES_DISPLAY' style="border:2px solid $OPTCOL;">
		<option value='on' $selected{'RULES_DISPLAY'}{'on'}>on</option>
		<option value='off' $selected{'RULES_DISPLAY'}{'off'}>off</option> </select></td>
		<td nowrap colspan='2' nowrap> <b><font size='0.5em'>$Lang::tr{'copfilter privoxy rules_info'} $copfiltersettings{'RULES_VERSION'}<br> $statusupdate</font></b></td>

</tr>

END
;

############# file date info##################
my $banner = '';
my $malware = '';
my $fandat = '';
my $adbdat = '';
my $plowdat = '';
my $elistdat = '';
my $eprivdat = '';
my $egerdat = '';
my $efrdat = '';
my $eitdat = '';
my $mdomdat = '';
my $hphdat = '';
my $mdomlistdat = '';
my $mcodedat = '';
my $mopbldat = '';
my $adverdat = '';
my $antisodat = '';


#fanboy version
if ($copfiltersettings{'COMPLETE_RULES'} eq 'on' ){
if ( -e "/var/log/copfilter/default/opt/privoxy/etc/fanboy.script.action" ){ 
$fandat = `ls -la --time-style=long-iso /var/log/copfilter/default/opt/privoxy/etc/ |grep fanboy.script.action | sed 's/  */ /g' | cut -d " " -f 6-7`;
$fandat = &Header::cleanhtml($fandat,"y"); 
$banner = "$Lang::tr{'copfilter privoxy rules_info2'}:";
}} 

#fanboy social version
if ($copfiltersettings{'COMPLETE_RULES1'} eq 'on' ){
if ( -e "/var/log/copfilter/default/opt/privoxy/etc/fanboysocial.script.action" ){ 
$adbdat = `ls -la --time-style=long-iso /var/log/copfilter/default/opt/privoxy/etc/ |grep fanboysocial.script.action | sed 's/  */ /g' | cut -d " " -f 6-7`;
$adbdat = &Header::cleanhtml($adbdat,"y"); 
$banner = "$Lang::tr{'copfilter privoxy rules_info2'}:";
}} 

#peter lowe version
if ($copfiltersettings{'COMPLETE_RULES3'} eq 'on' ){
if ( -e "/var/log/copfilter/default/opt/privoxy/etc/peter_lowe.script.action" ){ 
$plowdat = `ls -la --time-style=long-iso /var/log/copfilter/default/opt/privoxy/etc/ |grep peter_lowe.script.action | sed 's/  */ /g' | cut -d " " -f 6-7`;
$plowdat = &Header::cleanhtml($plowdat,"y"); 
$banner = "$Lang::tr{'copfilter privoxy rules_info2'}:";
}} 


if ( $privoxymodB eq 0 && $privoxyver eq 0 ){
#easy list version
if ($copfiltersettings{'COMPLETE_RULES6'} eq 'on' ){
if ( -e "/var/log/copfilter/default/opt/privoxy/etc/easylist.script.action" ){ 
$elistdat = `ls -la --time-style=long-iso /var/log/copfilter/default/opt/privoxy/etc/ |grep easylist.script.action | sed 's/  */ /g' | cut -d " " -f 6-7`;
$elistdat = &Header::cleanhtml($elistdat,"y"); 
$banner = "$Lang::tr{'copfilter privoxy rules_info2'}:";
}} 

#easy privacy version
if ($copfiltersettings{'COMPLETE_RULES7'} eq 'on' ){
if ( -e "/var/log/copfilter/default/opt/privoxy/etc/easyprivacy.script.action" ){ 
$eprivdat = `ls -la --time-style=long-iso /var/log/copfilter/default/opt/privoxy/etc/ |grep easyprivacy.script.action | sed 's/  */ /g' | cut -d " " -f 6-7`;
$eprivdat = &Header::cleanhtml($eprivdat,"y"); 
$banner = "$Lang::tr{'copfilter privoxy rules_info2'}:";
}} 

#easy ge version
if ($copfiltersettings{'COMPLETE_RULES8'} eq 'on' ){
if ( -e "/var/log/copfilter/default/opt/privoxy/etc/easylistgermany.script.action" ){ 
$egerdat = `ls -la --time-style=long-iso /var/log/copfilter/default/opt/privoxy/etc/ |grep easylistgermany.script.action | sed 's/  */ /g' | cut -d " " -f 6-7`;
$egerdat = &Header::cleanhtml($egerdat,"y"); 
$banner = "$Lang::tr{'copfilter privoxy rules_info2'}:";
}} 

#easy fr version
if ($copfiltersettings{'COMPLETE_RULES9'} eq 'on' ){
if ( -e "/var/log/copfilter/default/opt/privoxy/etc/easylistFR.script.action" ){ 
$efrdat = `ls -la --time-style=long-iso /var/log/copfilter/default/opt/privoxy/etc/ |grep easylistFR.script.action | sed 's/  */ /g' | cut -d " " -f 6-7`;
$efrdat = &Header::cleanhtml($efrdat,"y"); 
$banner = "$Lang::tr{'copfilter privoxy rules_info2'}:";
}} 

#easy it version
if ($copfiltersettings{'COMPLETE_RULES11'} eq 'on' ){
if ( -e "/var/log/copfilter/default/opt/privoxy/etc/easylistIT.script.action" ){ 
$eitdat = `ls -la --time-style=long-iso /var/log/copfilter/default/opt/privoxy/etc/ |grep easylistIT.script.action | sed 's/  */ /g' | cut -d " " -f 6-7`;
$eitdat = &Header::cleanhtml($eitdat,"y"); 
$banner = "$Lang::tr{'copfilter privoxy rules_info2'}:";
}}} 

if ( $privoxymodC eq 0 && $privoxyver eq 0 ){
#Adversity list version
if ($copfiltersettings{'COMPLETE_RULES13'} eq 'on' ){
if ( -e "/var/log/copfilter/default/opt/privoxy/etc/Adversity.script.action" ){ 
$adverdat = `ls -la --time-style=long-iso /var/log/copfilter/default/opt/privoxy/etc/ |grep Adversity.script.action | sed 's/  */ /g' | cut -d " " -f 6-7`;
$adverdat = &Header::cleanhtml($adverdat,"y"); 
$banner = "$Lang::tr{'copfilter privoxy rules_info2'}:";
}} 

#Antisocial version
if ($copfiltersettings{'COMPLETE_RULES14'} eq 'on' ){
if ( -e "/var/log/copfilter/default/opt/privoxy/etc/Antisocial.script.action" ){ 
$antisodat = `ls -la --time-style=long-iso /var/log/copfilter/default/opt/privoxy/etc/ |grep Antisocial.script.action | sed 's/  */ /g' | cut -d " " -f 6-7`;
$antisodat = &Header::cleanhtml($antisodat,"y"); 
$banner = "$Lang::tr{'copfilter privoxy rules_info2'}:";
}}} 

#maldomain version
if ($copfiltersettings{'COMPLETE_RULES2'} eq 'on' ){
if ( -e "/var/log/copfilter/default/opt/privoxy/etc/malwaredomains.script.action" ){ 
$mdomdat = `ls -la --time-style=long-iso /var/log/copfilter/default/opt/privoxy/etc/ |grep malwaredomains.script.action | sed 's/  */ /g' | cut -d " " -f 6-7`;
$mdomdat = &Header::cleanhtml($mdomdat,"y"); 
$malware = "$Lang::tr{'copfilter privoxy rules_info3'}:";
}} 

#hphost version
if ($copfiltersettings{'COMPLETE_RULES4'} eq 'on' ){
if ( -e "/var/log/copfilter/default/opt/privoxy/etc/HpHosts.script.action" ){ 
$hphdat = `ls -la --time-style=long-iso /var/log/copfilter/default/opt/privoxy/etc/ |grep HpHosts.script.action | sed 's/  */ /g' | cut -d " " -f 6-7`;
$hphdat = &Header::cleanhtml($hphdat,"y"); 
$malware = "$Lang::tr{'copfilter privoxy rules_info3'}:";
}} 

#maldomain list version
if ($copfiltersettings{'COMPLETE_RULES5'} eq 'on' ){
if ( -e "/var/log/copfilter/default/opt/privoxy/etc/malwaredomainlist.script.action" ){ 
$mdomlistdat = `ls -la --time-style=long-iso /var/log/copfilter/default/opt/privoxy/etc/ |grep malwaredomainlist.script.action | sed 's/  */ /g' | cut -d " " -f 6-7`;
$mdomlistdat = &Header::cleanhtml($mdomlistdat,"y"); 
$malware = "$Lang::tr{'copfilter privoxy rules_info3'}:";
}} 

if ( $privoxymodB eq 0 && $privoxyver eq 0 ){
#malcode version
if ($copfiltersettings{'COMPLETE_RULES10'} eq 'on' ){
if ( -e "/var/log/copfilter/default/opt/privoxy/etc/Malc0de.script.action" ){ 
$mcodedat = `ls -la --time-style=long-iso /var/log/copfilter/default/opt/privoxy/etc/ |grep Malc0de.script.action | sed 's/  */ /g' | cut -d " " -f 6-7`;
$mcodedat = &Header::cleanhtml($mcodedat,"y"); 
$malware = "$Lang::tr{'copfilter privoxy rules_info3'}:";
}} 

#openbl version
if ($copfiltersettings{'COMPLETE_RULES12'} eq 'on' ){
if ( -e "/var/log/copfilter/default/opt/privoxy/etc/openBL.script.action" ){ 
$mopbldat = `ls -la --time-style=long-iso /var/log/copfilter/default/opt/privoxy/etc/ |grep openBL.script.action | sed 's/  */ /g' | cut -d " " -f 6-7`;
$mopbldat = &Header::cleanhtml($mopbldat,"y"); 
$malware = "$Lang::tr{'copfilter privoxy rules_info3'}:";
}}}


if ( $banner ne '' ) {
print <<END
<tr>
<td nowrap colspan='5' valign='top'>
END
;
}

# $Lang::tr{'copfilter privoxy completes rules'}
if ( ! $banner eq '' ){
print "<b>$banner</b>";
print "<br>";
	if ( ! $fandat eq ''){
		print "<br>$fandat $Lang::tr{'copfilter privoxy completes rules'}";
	}
	if ( ! $adbdat eq ''){
		print "<br>$adbdat $Lang::tr{'copfilter privoxy completes rules1'}";
	}
	if ( ! $plowdat eq ''){
		print "<br>$plowdat $Lang::tr{'copfilter privoxy completes rules3'}";
	}
	if ( ! $elistdat eq ''){
		print "<br>$elistdat $Lang::tr{'copfilter privoxy completes rules6'}";
	}
	if ( ! $eprivdat eq ''){
		print "<br>$eprivdat $Lang::tr{'copfilter privoxy completes rules7'}";
	}
	if ( ! $egerdat eq ''){
		print "<br>$egerdat $Lang::tr{'copfilter privoxy completes rules8'}";
	}
	if ( ! $efrdat eq ''){
		print "<br>$efrdat $Lang::tr{'copfilter privoxy completes rules9'}";
	}
	if ( ! $eitdat eq ''){
		print "<br>$eitdat $Lang::tr{'copfilter privoxy completes rules11'}";
	}
	if ( ! $adverdat eq ''){
		print "<br>$adverdat $Lang::tr{'copfilter privoxy completes rules13'}";
	}
	if ( ! $antisodat eq ''){
		print "<br>$antisodat $Lang::tr{'copfilter privoxy completes rules14'}";
	}


if ( $malware eq '' ){
print <<END
</td>
</tr>
END
;
}
}

if ( $malware ne '' ){
if ( $banner ne '' ){
print <<END
</td>
<td nowrap colspan='5' valign='top'>
END
;}
else {
print <<END
<tr>
<td nowrap colspan='5' valign='top'>
END
;}

print "<b>$malware</b>";
print "<br>";
	if ( ! $mdomdat eq ''){
		print "<br>$mdomdat $Lang::tr{'copfilter privoxy completes rules2'}";
	}
	if ( ! $hphdat eq ''){
		print "<br>$hphdat $Lang::tr{'copfilter privoxy completes rules4'}";
	}
	if ( ! $mdomlistdat eq ''){
		print "<br>$mdomlistdat $Lang::tr{'copfilter privoxy completes rules5'}";
	}
	if ( ! $mcodedat eq ''){
		print "<br>$mcodedat $Lang::tr{'copfilter privoxy completes rules10'}";
	}
	if ( ! $mopbldat eq ''){
		print "<br>$mopbldat $Lang::tr{'copfilter privoxy completes rules12'}";
	}
print <<END
</td>
</tr>
END
;
}








##############################################
if ( $copfiltersettings{'RULES_DISPLAY'} eq 'on' ) {

    if ($copfiltersettings{'BASIC_RULES'} !~ /^off$/) {
        $OPTCOL='#009C28'; }
    else {
        $OPTCOL='#C1C1C1'; }


print <<END
<tr>
	<td nowrap colspan='2'> <b><font size='2.7em'>$Lang::tr{'copfilter privoxy basic rules'}</font></b></td>
	<td nowrap> <select name='BASIC_RULES' style="border:2px solid $OPTCOL;">
		<option value='on' $selected{'BASIC_RULES'}{'on'}>on</option>
		<option value='off' $selected{'BASIC_RULES'}{'off'}>off</option> </select></td>
</tr>
<tr>
	<td nowrap> &nbsp;</td>
</tr>

<tr>
	<td nowrap colspan='5'><font size='2.7em'> $Lang::tr{'copfilter privoxy rules_info2'}</td>
	<td nowrap colspan='5'><font size='2.7em'> $Lang::tr{'copfilter privoxy rules_info3'}</td>

<tr>
	<td nowrap></td>
</tr>
END
;
    if ($copfiltersettings{'COMPLETE_RULES'} !~ /^off$/) {
        $OPTCOL='#009C28'; }
    else {
        $OPTCOL='#C1C1C1'; }

print <<END
<tr>
				<td nowrap colspan='2'> $Lang::tr{'copfilter privoxy completes rules'}</td>
				<td nowrap> <select name='COMPLETE_RULES' style="border:2px solid $OPTCOL;">
					<option value='on' $selected{'COMPLETE_RULES'}{'on'}>on</option>
					<option value='off' $selected{'COMPLETE_RULES'}{'off'}>off</option> </select> </td>
				<td nowrap colspan='2'></td>
END
;

    if ($copfiltersettings{'COMPLETE_RULES2'} !~ /^off$/) {
        $OPTCOL='#009C28'; }
    else {
        $OPTCOL='#C1C1C1'; }


print <<END
 
	<td nowrap colspan='2'> $Lang::tr{'copfilter privoxy completes rules2'}</td>
	<td nowrap> <select name='COMPLETE_RULES2' style="border:2px solid $OPTCOL;">
		<option value='on' $selected{'COMPLETE_RULES2'}{'on'}>on</option>
		<option value='off' $selected{'COMPLETE_RULES2'}{'off'}>off</option> </select> </td>
				<td nowrap colspan='2'></td>

</tr>
END
;


    if ($copfiltersettings{'COMPLETE_RULES1'} !~ /^off$/) {
        $OPTCOL='#009C28'; }
    else {
        $OPTCOL='#C1C1C1'; }
print <<END
<tr>
	<td nowrap colspan='2'> $Lang::tr{'copfilter privoxy completes rules1'}</td>
	<td nowrap> <select name='COMPLETE_RULES1' style="border:2px solid $OPTCOL;">
		<option value='on' $selected{'COMPLETE_RULES1'}{'on'}>on</option>
		<option value='off' $selected{'COMPLETE_RULES1'}{'off'}>off</option> </select> </td>
				<td nowrap colspan='2'></td>
END
;


    if ($copfiltersettings{'COMPLETE_RULES4'} !~ /^off$/) {
        $OPTCOL='#009C28'; }
    else {
        $OPTCOL='#C1C1C1'; }


print <<END
	<td nowrap colspan='2'> $Lang::tr{'copfilter privoxy completes rules4'}</td>
	<td nowrap> <select name='COMPLETE_RULES4' style="border:2px solid $OPTCOL;">
		<option value='on' $selected{'COMPLETE_RULES4'}{'on'}>on</option>
		<option value='off' $selected{'COMPLETE_RULES4'}{'off'}>off</option> </select></td>
				<td nowrap colspan='2'></td>
</tr>
END
;

    if ($copfiltersettings{'COMPLETE_RULES3'} !~ /^off$/) {
        $OPTCOL='#009C28'; }
    else {
        $OPTCOL='#C1C1C1'; }

print <<END
<tr>
	<td nowrap colspan='2'> $Lang::tr{'copfilter privoxy completes rules3'}</td>
	<td nowrap> <select name='COMPLETE_RULES3' style="border:2px solid $OPTCOL;">
		<option value='on' $selected{'COMPLETE_RULES3'}{'on'}>on</option>
		<option value='off' $selected{'COMPLETE_RULES3'}{'off'}>off</option> </select> </td>
				<td nowrap colspan='2'></td>
END
;

    if ($copfiltersettings{'COMPLETE_RULES5'} !~ /^off$/) {
        $OPTCOL='#009C28'; }
    else {
        $OPTCOL='#C1C1C1'; }


print <<END
	<td nowrap colspan='2'> $Lang::tr{'copfilter privoxy completes rules5'}</td>
	<td nowrap> <select name='COMPLETE_RULES5' style="border:2px solid $OPTCOL;">
		<option value='on' $selected{'COMPLETE_RULES5'}{'on'}>on</option>
		<option value='off' $selected{'COMPLETE_RULES5'}{'off'}>off</option> </select></td>
				<td nowrap colspan='2'></td>

</tr>
END
;


if ( $privoxyver eq 0) {

if ( $privoxymodB eq 0) {

    if ($copfiltersettings{'COMPLETE_RULES6'} !~ /^off$/) {
        $OPTCOL='#009C28'; }
    else {
        $OPTCOL='#C1C1C1'; }



print <<END
			       
<tr>
	<td nowrap colspan='2'> $Lang::tr{'copfilter privoxy completes rules6'}</td>
	<td nowrap> <select name='COMPLETE_RULES6' style="border:2px solid $OPTCOL;">
		<option value='on' $selected{'COMPLETE_RULES6'}{'on'}>on</option>
		<option value='off' $selected{'COMPLETE_RULES6'}{'off'}>off</option> </select> </td>
				<td nowrap colspan='2'></td>

END
;

    if ($copfiltersettings{'COMPLETE_RULES10'} !~ /^off$/) {
        $OPTCOL='#009C28'; }
    else {
        $OPTCOL='#C1C1C1'; }


print <<END

	<td nowrap colspan='2'> $Lang::tr{'copfilter privoxy completes rules10'}</td>
	<td nowrap> <select name='COMPLETE_RULES10' style="border:2px solid $OPTCOL;">
		<option value='on' $selected{'COMPLETE_RULES10'}{'on'}>on</option>
		<option value='off' $selected{'COMPLETE_RULES10'}{'off'}>off</option> </select></td>
				<td nowrap colspan='2'></td>

</tr>
END
;


    if ($copfiltersettings{'COMPLETE_RULES7'} !~ /^off$/) {
        $OPTCOL='#009C28'; }
    else {
        $OPTCOL='#C1C1C1'; }



print <<END
			       
<tr>
	<td nowrap colspan='2'> $Lang::tr{'copfilter privoxy completes rules7'}</td>
	<td nowrap> <select name='COMPLETE_RULES7' style="border:2px solid $OPTCOL;">
		<option value='on' $selected{'COMPLETE_RULES7'}{'on'}>on</option>
		<option value='off' $selected{'COMPLETE_RULES7'}{'off'}>off</option> </select> </td>
				<td nowrap colspan='2'></td>
END
;

    if ($copfiltersettings{'COMPLETE_RULES12'} !~ /^off$/) {
        $OPTCOL='#009C28'; }
    else {
        $OPTCOL='#C1C1C1'; }


print <<END

	<td nowrap colspan='2'> $Lang::tr{'copfilter privoxy completes rules12'}</td>
	<td nowrap> <select name='COMPLETE_RULES12' style="border:2px solid $OPTCOL;">
		<option value='on' $selected{'COMPLETE_RULES12'}{'on'}>on</option>
		<option value='off' $selected{'COMPLETE_RULES12'}{'off'}>off</option> </select></td>
				<td nowrap colspan='2'></td>

</tr>
END
;


    if ($copfiltersettings{'COMPLETE_RULES8'} !~ /^off$/) {
        $OPTCOL='#009C28'; }
    else {
        $OPTCOL='#C1C1C1'; }



print <<END
			       
<tr>
	<td nowrap colspan='2'> $Lang::tr{'copfilter privoxy completes rules8'}</td>
	<td nowrap> <select name='COMPLETE_RULES8' style="border:2px solid $OPTCOL;">
		<option value='on' $selected{'COMPLETE_RULES8'}{'on'}>on</option>
		<option value='off' $selected{'COMPLETE_RULES8'}{'off'}>off</option> </select> </td>
				<td nowrap colspan='2'></td>
</tr>


END
;


    if ($copfiltersettings{'COMPLETE_RULES9'} !~ /^off$/) {
        $OPTCOL='#009C28'; }
    else {
        $OPTCOL='#C1C1C1'; }



print <<END
			       
<tr>
	<td nowrap colspan='2'> $Lang::tr{'copfilter privoxy completes rules9'}</td>
	<td nowrap> <select name='COMPLETE_RULES9' style="border:2px solid $OPTCOL;">
		<option value='on' $selected{'COMPLETE_RULES9'}{'on'}>on</option>
		<option value='off' $selected{'COMPLETE_RULES9'}{'off'}>off</option> </select> </td>
				<td nowrap colspan='2'></td>
</tr>
END
;
    if ($copfiltersettings{'COMPLETE_RULES11'} !~ /^off$/) {
        $OPTCOL='#009C28'; }
    else {
        $OPTCOL='#C1C1C1'; }



print <<END
			       
<tr>
	<td nowrap colspan='2'> $Lang::tr{'copfilter privoxy completes rules11'}</td>
	<td nowrap> <select name='COMPLETE_RULES11' style="border:2px solid $OPTCOL;">
		<option value='on' $selected{'COMPLETE_RULES11'}{'on'}>on</option>
		<option value='off' $selected{'COMPLETE_RULES11'}{'off'}>off</option> </select> </td>
				<td nowrap colspan='2'></td>
</tr>
END
;







if ( $privoxyver eq 0) {

if ( $privoxymodC eq 0) {


    if ($copfiltersettings{'COMPLETE_RULES13'} !~ /^off$/) {
        $OPTCOL='#009C28'; }
    else {
        $OPTCOL='#C1C1C1'; }



print <<END
			       
<tr>
	<td nowrap colspan='2'> $Lang::tr{'copfilter privoxy completes rules13'}</td>
	<td nowrap> <select name='COMPLETE_RULES13' style="border:2px solid $OPTCOL;">
		<option value='on' $selected{'COMPLETE_RULES13'}{'on'}>on</option>
		<option value='off' $selected{'COMPLETE_RULES13'}{'off'}>off</option> </select> </td>
				<td nowrap colspan='2'></td>
</tr>
END
;
    if ($copfiltersettings{'COMPLETE_RULES14'} !~ /^off$/) {
        $OPTCOL='#009C28'; }
    else {
        $OPTCOL='#C1C1C1'; }



print <<END
			       
<tr>
	<td nowrap colspan='2'> $Lang::tr{'copfilter privoxy completes rules14'}</td>
	<td nowrap> <select name='COMPLETE_RULES14' style="border:2px solid $OPTCOL;">
		<option value='on' $selected{'COMPLETE_RULES14'}{'on'}>on</option>
		<option value='off' $selected{'COMPLETE_RULES14'}{'off'}>off</option> </select> </td>
				<td nowrap colspan='2'></td>
</tr>
END
;

}
}


    if ($copfiltersettings{'PRIVOXY_MAIL_NOTIF'} !~ /^off$/) {
        $OPTCOL='#009C28'; }
    else {
        $OPTCOL='#C1C1C1'; }

print <<END
<tr>
	<td nowrap> &nbsp;</td>
</tr>

       <td nowrap colspan='2'>$Lang::tr{'copfilter upd_mail_notif'}&nbsp; </td>
       <td nowrap><select name='PRIVOXY_MAIL_NOTIF' style="border:2px solid $OPTCOL;">
            <option value='on' $selected{'PRIVOXY_MAIL_NOTIF'}{'on'}>on</option>
	     <option value='off' $selected{'PRIVOXY_MAIL_NOTIF'}{'off'}>off</option></select></td>
       <td nowrap> </td>
       <td nowrap> </td>


END
;



print <<END
<tr>
	<td nowrap> &nbsp;</td>
</tr>

</font>
<tr>
  
        <td nowrap colspan='2'><b>$Lang::tr{'copfilter privoxy automatic update'}:</b></td>       
        <td nowrap colspan='1'><b>$Lang::tr{'copfilter manual update'}:</b></td>
</tr>
</td>
        <td nowrap valign='top'><input type='radio' name='PRIVOXY_UPDATE_METHOD' value='periodically' $selected{'PRIVOXY_UPDATE_METHOD'}{'periodically'} />$Lang::tr{'copfilter enabled every'}: <br />
        <input type='radio' name='PRIVOXY_UPDATE_METHOD' value='manually' $selected{'PRIVOXY_UPDATE_METHOD'}{'manually'} />$Lang::tr{'copfilter disabled'}</td>
        <td nowrap valign='top'><input type='text' name='PRIVOXY_UPDATE_VALUE' size='3' maxlength='3' value='$copfiltersettings{'PRIVOXY_UPDATE_VALUE'}' />
        <select name='PRIVOXY_UPDATE_PERIOD'>
                <option value='hourly' $selected{'PRIVOXY_UPDATE_PERIOD'}{'hourly'}>$Lang::tr{'copfilter hours'}</option>
                <option value='daily' $selected{'PRIVOXY_UPDATE_PERIOD'}{'daily'}>$Lang::tr{'copfilter days'}</option>
                <option value='weekly' $selected{'PRIVOXY_UPDATE_PERIOD'}{'weekly'}>$Lang::tr{'copfilter weeks'}</option>
                <option value='monthly' $selected{'PRIVOXY_UPDATE_PERIOD'}{'monthly'}>$Lang::tr{'copfilter months'}</option>



       <td nowrap valign='top'><input type='submit' name='ACTION' value='$Lang::tr{'copfilter privoxy update now'}' />  

END
;
	if ( -e "${copfilter_swroot}/etc/copfilter_check-updates_privoxy.done" ){				
  		print "<font color='#339933'>DONE</font>";
   		system ('/bin/rm', "${copfilter_swroot}/etc/copfilter_check-updates_privoxy.done");
	}




print <<END
<tr>

	<td nowrap colspan='5'>$Lang::tr{'copfilter privoxy update info'}</td>

</tr>

END
;

######### zum naechsten Privoxy Update ################
if ( -e "${copfilter_swroot}/etc/privoxy_counter" && $copfiltersettings{'PRIVOXY_UPDATE_METHOD'} eq 'periodically' ){
	my $nextupd = '';
	my $nexttime = 0;
	my $nextday = 0;
	my $nexthour = 0;
	my $nextminute = 0;
	$nexttime = `cat /var/log/copfilter/default/etc/privoxy_counter` + 5;

	$nextday = ($nexttime - $nexttime % 1440) / 1440;
	$nexthour = ($nexttime % 1440 - $nexttime % 1440 % 60) / 60;
	$nextminute = $nexttime - $nextday * 1440 - $nexthour * 60;

	if ($nextday > 0){
		if ($nexthour < 10 ){ $nexthour = "0$nexthour"; }
		if ($nextminute < 10){ $nextminute = "0$nextminute"; }
	$nextupd = "<br><br><b>$nextday:$nexthour:$nextminute $Lang::tr{'copfilter days'} $Lang::tr{'privoxy_update'} </b>";
	}elsif($nexthour > 0){
		if ($nextminute < 10){ $nextminute = "0$nextminute"; }
		$nextupd = "<br><br><b>$nexthour:$nextminute $Lang::tr{'copfilter hours'} $Lang::tr{'privoxy_update'} </b>";
	}else{
		$nextupd = "<br><br><b>$nextminute $Lang::tr{'copfilter minutes'} $Lang::tr{'privoxy_update'} </b>";}


print <<END

       <td nowrap colspan='2'><b>$nextupd</b></td>       
 

END
;
}



}
}
}


}


print <<END
<tr>
	<td nowrap> &nbsp;</td>
</tr>
<tr>
	<td nowrap> &nbsp;</td>
</tr>

</table>
END
;
















if ( $privoxymodD eq 0) {


print <<END
<table width='100%' border='0' cellpadding='5'>


<tr>
	<td nowrap width='11%'></td>
	<td nowrap width='14%'></td>
	<td nowrap width='75%'></td>
</tr>

    <td nowrap><font size='2.7em'><b>DNS Filtering Status:</b></td>
    $statusdns
</tr>
<tr>
	<td nowrap></td>
</tr>
</table>
<table>
<td>  $Lang::tr{'copfilter DNS filtering_info1'}</td>
</table>

END
;


    if ($copfiltersettings{'DNS_FILTERING'} !~ /^default$/) {
        $OPTCOL='#009C28'; }
    else {
        $OPTCOL='#C1C1C1'; }




print <<END

<table width='100%' border='0' cellpadding='5'>
<tr>
	<td nowrap width='11%'></td>
	<td nowrap width='10%'></td>
	<td nowrap width='7%'></td>
	<td nowrap width='3%'></td>
	<td nowrap width='19%'></td>
	<td nowrap width='11%'></td>
	<td nowrap width='14%'></td>
	<td nowrap width='3%'></td>
	<td nowrap width='3%'></td>
	<td nowrap width='19%'></td>
</tr>




<tr>
</tr>



	
        <td nowrap > $Lang::tr{'copfilter DNS filtering'} </td>
	<td nowrap> &nbsp;</td>
	
	<td nowrap colspan='3'><select name='DNS_FILTERING' style="border:2px solid $OPTCOL;">
		<option value='Comodo SecureDNS' $selected{'DNS_FILTERING'}{'Comodo SecureDNS'}>Comodo SecureDNS</option>
		<option value='Norton ConnectSafe 1' $selected{'DNS_FILTERING'}{'Norton ConnectSafe 1'}>Norton ConnectSafe 1</option>
		<option value='Norton ConnectSafe 2' $selected{'DNS_FILTERING'}{'Norton ConnectSafe 2'}>Norton ConnectSafe 2</option>
		<option value='OpenDNS' $selected{'DNS_FILTERING'}{'OpenDNS'}>OpenDNS</option>
		<option value='default' $selected{'DNS_FILTERING'}{'default'}>default</option> </select></td>
		
</tr>

<tr>
	<td nowrap></td>
</tr>

</table>
<table>
<tr>
<td> $Lang::tr{'copfilter DNS warning'} </td>
</tr>
<tr>
 <td> 1.$Lang::tr{'copfilter DNS SecureDNS'} </td>
</tr>
<tr>
 <td> 2.$Lang::tr{'copfilter DNS Norton1'}</td>
</tr>
<tr>
 <td> 3.$Lang::tr{'copfilter DNS Norton2'}</td>
</tr>
<tr>
 <td> 4.$Lang::tr{'copfilter DNS Opendns'}</td>
</tr>
<tr>
	<td nowrap></td>
</tr>
<td> $Lang::tr{'copfilter DNS filtering_info2'}  </td>

<tr>
	<td nowrap> &nbsp;</td>
</tr>


</table>


END
;
}






















print <<END
<table width='100%' border='0' cellpadding='5'>
<tr>
	<td nowrap width='100%'></td>
</tr>
<tr>
	<td nowrap></td>
</tr>
<tr>
    <td nowrap> $Lang::tr{'copfilter http note'} </td>
</tr>
<tr>
    <td nowrap> 
        $Lang::tr{'copfilter http restart'} <br />
        $Lang::tr{'copfilter http_avg_note'}
    </td>
</tr>

</table>

<table border='0'>
<tr>
        <td nowrap valign='bottom' width='50%'>
            <input type='checkbox' name='SKIP_RESTART' />
             $Lang::tr{'copfilter skip restart'}
        <br>
        <input type='submit' name='ACTION' value='$Lang::tr{'copfilter save'}' /> </td>
	<td width='50%' nowrap valign='bottom' align='right'><img src='/images/copfilter-logo.png' width='120' height='48' alt='*'></td>
</tr>

</table>
END
;

print "</form>\n";
&Header::closebox();
print "<br />\n";


# For Testing
#print "<pre>";
#$output = `cat /var/log/copfilter/default/etc/global_settings`;
#print "$output\n";
#print "</pre>";
&Header::closebigbox();

&Header::closepage();


}
